SUBROUTINE TEST_SIMPLE_LOGICAL(A,C,B)
  USE ISO_C_BINDING, ONLY: C_BOOL
  LOGICAL, INTENT(IN), DIMENSION(:) :: A
  LOGICAL(KIND=C_BOOL), INTENT(IN), OPTIONAL :: C
  LOGICAL(KIND=C_BOOL), INTENT(OUT), DIMENSION(SIZE(A)) :: B
  ! Local
  INTEGER :: I
  B(:) = .TRUE.
  DO I = 1, SIZE(B)
     IF (PRESENT(C) .AND. (C)) THEN
        B(I) = (MOD(I,2) .EQ. 0)
     ELSE
        B(I) = (MOD(I,3) .EQ. 0)
     END IF
  END DO
END SUBROUTINE TEST_SIMPLE_LOGICAL

! python3 -c "import fmodpy as f; f.fimport('simple_logical.f03', build_dir='.', verbose=True)"
! python3 -c "import og_fmodpy as f; f.wrap('simple_logical.f03', working_directory='og_fmodpy', verbose=True)"

! Test Fortran REAL wrapping and usage from Python with fmodpy.

SUBROUTINE TEST_STANDARD(SING_IN, SING_OUT, ARRAY_IN, ARRAY_OUT,&
     KNOWN_ARRAY_OUT, KNOWN_MATRIX_OUT, OPT_SING_IN, OPT_SING_OUT)
  ! Test the basic functionaly of the 'REAL' type and its
  ! interoperability with Python. This includes, inputs, outputs,
  ! array inputs with known and unknown size, optional inputs, and
  ! optional outputs. 
  USE ISO_FORTRAN_ENV, ONLY: REAL64
  IMPLICIT NONE
  ! Argument definitions.
  REAL(KIND=REAL64), INTENT(IN) :: SING_IN
  REAL(KIND=REAL64), INTENT(OUT) :: SING_OUT
  REAL(KIND=REAL64), DIMENSION(:), INTENT(IN) :: ARRAY_IN
  REAL(KIND=REAL64), DIMENSION(:), INTENT(OUT) :: ARRAY_OUT
  REAL(KIND=REAL64), DIMENSION(SIZE(ARRAY_OUT)), INTENT(OUT) :: KNOWN_ARRAY_OUT
  REAL(KIND=REAL64), DIMENSION(3,SIZE(ARRAY_OUT)), INTENT(OUT) :: KNOWN_MATRIX_OUT
  REAL(KIND=REAL64), INTENT(IN), OPTIONAL :: OPT_SING_IN
  REAL(KIND=REAL64), INTENT(OUT), OPTIONAL :: OPT_SING_OUT
  ! Local variable.
  INTEGER :: I
  ! Copy the single input value to the single output value.
  SING_OUT = SING_IN + 1
  ! Copy as much of the input array as possible to the output array.
  ARRAY_OUT(1:MIN(SIZE(ARRAY_IN),SIZE(ARRAY_OUT))) = &
       &ARRAY_IN(1:MIN(SIZE(ARRAY_IN),SIZE(ARRAY_OUT)))
  DO I = MIN(SIZE(ARRAY_IN),SIZE(ARRAY_OUT))+1, SIZE(ARRAY_OUT)
     ARRAY_OUT(I) = I
  END DO
  DO I = 1, SIZE(KNOWN_MATRIX_OUT, 1)
     KNOWN_MATRIX_OUT(I,:) = I
  END DO
  ! Set the KNOWN_ARRAY and the KNOWN_MATRIX values to be identifiabl.
  DO I = 1,SIZE(ARRAY_OUT)
     KNOWN_ARRAY_OUT(I) = I
     KNOWN_MATRIX_OUT(:,I) = KNOWN_MATRIX_OUT(:,I) + I
  END DO
  ! Do some operations on the optional inputs / outputs.
  IF (PRESENT(OPT_SING_OUT)) THEN
     IF (PRESENT(OPT_SING_IN)) THEN
        OPT_SING_OUT = OPT_SING_IN
     ELSE
        OPT_SING_OUT = SING_IN
     END IF
  ELSE IF (PRESENT(OPT_SING_IN)) THEN
     SING_OUT = OPT_SING_IN
  END IF
  ! End of this subroutine.
END SUBROUTINE TEST_STANDARD


FUNCTION TEST_EXTENDED(OPT_ARRAY_IN, KNOWN_OPT_ARRAY_OUT,&
     & OPT_ALLOC_ARRAY_OUT, N ) RESULT(ALLOC_ARRAY_OUT)
  ! Test the extended functionaly of the 'REAL' type and its
  ! interoperability with Python. This includes, optional array
  ! inputs, optional array outputs, and allocatable array outputs.
  USE ISO_FORTRAN_ENV, ONLY: REAL64
  IMPLICIT NONE
  REAL(REAL64), INTENT(IN), OPTIONAL, DIMENSION(:) :: OPT_ARRAY_IN
  REAL(REAL64), INTENT(OUT), OPTIONAL :: KNOWN_OPT_ARRAY_OUT(3)
  REAL(REAL64), INTENT(OUT), OPTIONAL, ALLOCATABLE :: OPT_ALLOC_ARRAY_OUT(:)
  REAL(REAL64), DIMENSION(:), ALLOCATABLE :: ALLOC_ARRAY_OUT
  INTEGER, INTENT(IN) :: N
  ! Local variable.
  INTEGER :: I

  ! Assign the optional array output values.
  IF (PRESENT(KNOWN_OPT_ARRAY_OUT)) THEN
     IF (PRESENT(OPT_ARRAY_IN)) THEN
        DO I = 1, MIN(SIZE(OPT_ARRAY_IN), SIZE(KNOWN_OPT_ARRAY_OUT))
           KNOWN_OPT_ARRAY_OUT(I) = I
        END DO
     ELSE
        DO I = 1, SIZE(KNOWN_OPT_ARRAY_OUT)
           KNOWN_OPT_ARRAY_OUT(I) = I
        END DO
     END IF
  END IF

  ! Allocate the optional array output and assign its values.
  IF (PRESENT(OPT_ALLOC_ARRAY_OUT)) THEN
     ALLOCATE(OPT_ALLOC_ARRAY_OUT(1:N/2))
     DO I = 1, SIZE(OPT_ALLOC_ARRAY_OUT)
        OPT_ALLOC_ARRAY_OUT(I) = SIZE(OPT_ALLOC_ARRAY_OUT) - (I-1)
     END DO
  END IF
  
  ! Allocate the required array output to the specified size.
  ALLOCATE(ALLOC_ARRAY_OUT(1:N))
  DO I = 1, SIZE(ALLOC_ARRAY_OUT)
     ALLOC_ARRAY_OUT(I) = SIZE(ALLOC_ARRAY_OUT) - (I-1)
  END DO
  
  ! End of function.
END FUNCTION TEST_EXTENDED

! This automatically generated Fortran wrapper file allows codes
! written in Fortran to be called directly from C and translates all
! C-style arguments into expected Fortran-style arguments (with
! assumed size, local type declarations, etc.).


SUBROUTINE C_TEST_STANDARD(SING_IN, SING_OUT, ARRAY_IN_DIM_1, ARRAY_IN, ARRAY_OUT_DIM_1, ARRAY_OUT, KNOWN_ARRAY_OUT_DIM_1, KNOWN_AR&
&RAY_OUT, KNOWN_MATRIX_OUT_DIM_1, KNOWN_MATRIX_OUT_DIM_2, KNOWN_MATRIX_OUT, OPT_SING_IN_PRESENT, OPT_SING_IN, OPT_SING_OUT_PRESENT,&
& OPT_SING_OUT) BIND(C)
  USE ISO_FORTRAN_ENV , ONLY : REAL128
  USE ISO_FORTRAN_ENV , ONLY : REAL128
  IMPLICIT NONE
  COMPLEX(KIND=REAL128), INTENT(IN) :: SING_IN
  COMPLEX(KIND=REAL128), INTENT(OUT) :: SING_OUT
  INTEGER, INTENT(IN) :: ARRAY_IN_DIM_1
  COMPLEX(KIND=REAL128), INTENT(IN), DIMENSION(ARRAY_IN_DIM_1) :: ARRAY_IN
  INTEGER, INTENT(IN) :: ARRAY_OUT_DIM_1
  COMPLEX(KIND=REAL128), INTENT(OUT), DIMENSION(ARRAY_OUT_DIM_1) :: ARRAY_OUT
  INTEGER, INTENT(IN) :: KNOWN_ARRAY_OUT_DIM_1
  COMPLEX(KIND=REAL128), INTENT(OUT), DIMENSION(KNOWN_ARRAY_OUT_DIM_1) :: KNOWN_ARRAY_OUT
  INTEGER, INTENT(IN) :: KNOWN_MATRIX_OUT_DIM_1
  INTEGER, INTENT(IN) :: KNOWN_MATRIX_OUT_DIM_2
  COMPLEX(KIND=REAL128), INTENT(OUT), DIMENSION(KNOWN_MATRIX_OUT_DIM_1,KNOWN_MATRIX_OUT_DIM_2) :: KNOWN_MATRIX_OUT
  LOGICAL, INTENT(IN) :: OPT_SING_IN_PRESENT
  COMPLEX(KIND=REAL128), INTENT(IN) :: OPT_SING_IN
  LOGICAL, INTENT(IN) :: OPT_SING_OUT_PRESENT
  COMPLEX(KIND=REAL128), INTENT(OUT) :: OPT_SING_OUT

  INTERFACE
    SUBROUTINE TEST_STANDARD(SING_IN, SING_OUT, ARRAY_IN, ARRAY_OUT, KNOWN_ARRAY_OUT, KNOWN_MATRIX_OUT, OPT_SING_IN, OPT_SING_OUT)
      ! Test the basic functionaly of the 'COMPLEX' type and its
      ! interoperability with Python. This includes, inputs, outputs,
      ! array inputs with known and unknown size, optional inputs, and
      ! optional outputs.
      USE ISO_FORTRAN_ENV , ONLY : REAL128
      USE ISO_FORTRAN_ENV , ONLY : REAL128
      IMPLICIT NONE
      COMPLEX(KIND=REAL128), INTENT(IN) :: SING_IN
      COMPLEX(KIND=REAL128), INTENT(OUT) :: SING_OUT
      COMPLEX(KIND=REAL128), INTENT(IN), DIMENSION(:) :: ARRAY_IN
      COMPLEX(KIND=REAL128), INTENT(OUT), DIMENSION(:) :: ARRAY_OUT
      COMPLEX(KIND=REAL128), INTENT(OUT), DIMENSION(SIZE(ARRAY_OUT)) :: KNOWN_ARRAY_OUT
      COMPLEX(KIND=REAL128), INTENT(OUT), DIMENSION(3,SIZE(ARRAY_OUT)) :: KNOWN_MATRIX_OUT
      COMPLEX(KIND=REAL128), INTENT(IN), OPTIONAL :: OPT_SING_IN
      COMPLEX(KIND=REAL128), INTENT(OUT), OPTIONAL :: OPT_SING_OUT
    END SUBROUTINE TEST_STANDARD
  END INTERFACE

  IF (OPT_SING_IN_PRESENT) THEN
    IF (OPT_SING_OUT_PRESENT) THEN
      CALL TEST_STANDARD(SING_IN=SING_IN, SING_OUT=SING_OUT, ARRAY_IN=ARRAY_IN, ARRAY_OUT=ARRAY_OUT, KNOWN_ARRAY_OUT=KNOWN_ARRAY_OU&
&T, KNOWN_MATRIX_OUT=KNOWN_MATRIX_OUT, OPT_SING_IN=OPT_SING_IN, OPT_SING_OUT=OPT_SING_OUT)
    ELSE
      CALL TEST_STANDARD(SING_IN=SING_IN, SING_OUT=SING_OUT, ARRAY_IN=ARRAY_IN, ARRAY_OUT=ARRAY_OUT, KNOWN_ARRAY_OUT=KNOWN_ARRAY_OU&
&T, KNOWN_MATRIX_OUT=KNOWN_MATRIX_OUT, OPT_SING_IN=OPT_SING_IN)
    END IF
  ELSE
    IF (OPT_SING_OUT_PRESENT) THEN
      CALL TEST_STANDARD(SING_IN=SING_IN, SING_OUT=SING_OUT, ARRAY_IN=ARRAY_IN, ARRAY_OUT=ARRAY_OUT, KNOWN_ARRAY_OUT=KNOWN_ARRAY_OU&
&T, KNOWN_MATRIX_OUT=KNOWN_MATRIX_OUT, OPT_SING_OUT=OPT_SING_OUT)
    ELSE
      CALL TEST_STANDARD(SING_IN=SING_IN, SING_OUT=SING_OUT, ARRAY_IN=ARRAY_IN, ARRAY_OUT=ARRAY_OUT, KNOWN_ARRAY_OUT=KNOWN_ARRAY_OU&
&T, KNOWN_MATRIX_OUT=KNOWN_MATRIX_OUT)
    END IF
  END IF
END SUBROUTINE C_TEST_STANDARD


SUBROUTINE C_TEST_EXTENDED(OPT_ARRAY_IN_PRESENT, OPT_ARRAY_IN_DIM_1, OPT_ARRAY_IN, KNOWN_OPT_ARRAY_OUT_PRESENT, KNOWN_OPT_ARRAY_OUT&
&_DIM_1, KNOWN_OPT_ARRAY_OUT, OPT_ALLOC_ARRAY_OUT_PRESENT, OPT_ALLOC_ARRAY_OUT_DIM_1, OPT_ALLOC_ARRAY_OUT, N, ALLOC_ARRAY_OUT_DIM_1&
&, ALLOC_ARRAY_OUT) BIND(C)
  USE ISO_FORTRAN_ENV , ONLY : REAL128
  USE ISO_FORTRAN_ENV, ONLY: INT64
  IMPLICIT NONE
  LOGICAL, INTENT(IN) :: OPT_ARRAY_IN_PRESENT
  INTEGER, INTENT(IN) :: OPT_ARRAY_IN_DIM_1
  COMPLEX(KIND=REAL128), INTENT(IN), DIMENSION(OPT_ARRAY_IN_DIM_1) :: OPT_ARRAY_IN
  LOGICAL, INTENT(IN) :: KNOWN_OPT_ARRAY_OUT_PRESENT
  INTEGER, INTENT(IN) :: KNOWN_OPT_ARRAY_OUT_DIM_1
  COMPLEX(KIND=REAL128), INTENT(OUT), DIMENSION(KNOWN_OPT_ARRAY_OUT_DIM_1) :: KNOWN_OPT_ARRAY_OUT
  LOGICAL, INTENT(IN) :: OPT_ALLOC_ARRAY_OUT_PRESENT
  INTEGER, INTENT(OUT) :: OPT_ALLOC_ARRAY_OUT_DIM_1
  COMPLEX(KIND=REAL128), ALLOCATABLE, SAVE, DIMENSION(:) :: OPT_ALLOC_ARRAY_OUT_LOCAL
  INTEGER(KIND=INT64), INTENT(OUT) :: OPT_ALLOC_ARRAY_OUT
  INTEGER, INTENT(IN) :: N
  INTEGER, INTENT(OUT) :: ALLOC_ARRAY_OUT_DIM_1
  COMPLEX(KIND=REAL128), ALLOCATABLE, SAVE, DIMENSION(:) :: ALLOC_ARRAY_OUT_LOCAL
  INTEGER(KIND=INT64), INTENT(OUT) :: ALLOC_ARRAY_OUT

  INTERFACE
    FUNCTION TEST_EXTENDED(OPT_ARRAY_IN, KNOWN_OPT_ARRAY_OUT, OPT_ALLOC_ARRAY_OUT, N) RESULT(ALLOC_ARRAY_OUT)
      ! Test the extended functionaly of the 'COMPLEX' type and its
      ! interoperability with Python. This includes, optional array
      ! inputs, optional array outputs, and allocatable array outputs.
      USE ISO_FORTRAN_ENV , ONLY : REAL128
      IMPLICIT NONE
      COMPLEX(KIND=REAL128), INTENT(IN), OPTIONAL, DIMENSION(:) :: OPT_ARRAY_IN
      COMPLEX(KIND=REAL128), INTENT(OUT), OPTIONAL, DIMENSION(3) :: KNOWN_OPT_ARRAY_OUT
      COMPLEX(KIND=REAL128), INTENT(OUT), OPTIONAL, ALLOCATABLE, DIMENSION(:) :: OPT_ALLOC_ARRAY_OUT
      INTEGER, INTENT(IN) :: N
      COMPLEX(KIND=REAL128), ALLOCATABLE, DIMENSION(:) :: ALLOC_ARRAY_OUT
    END FUNCTION TEST_EXTENDED
  END INTERFACE

  IF (OPT_ARRAY_IN_PRESENT) THEN
    IF (KNOWN_OPT_ARRAY_OUT_PRESENT) THEN
      IF (OPT_ALLOC_ARRAY_OUT_PRESENT) THEN
        ALLOC_ARRAY_OUT_LOCAL = TEST_EXTENDED(N=N, OPT_ARRAY_IN=OPT_ARRAY_IN, KNOWN_OPT_ARRAY_OUT=KNOWN_OPT_ARRAY_OUT, OPT_ALLOC_AR&
&RAY_OUT=OPT_ALLOC_ARRAY_OUT_LOCAL)
        OPT_ALLOC_ARRAY_OUT_DIM_1 = SIZE(OPT_ALLOC_ARRAY_OUT_LOCAL,1)
        OPT_ALLOC_ARRAY_OUT = LOC(OPT_ALLOC_ARRAY_OUT_LOCAL(1))
      ELSE
        ALLOC_ARRAY_OUT_LOCAL = TEST_EXTENDED(N=N, OPT_ARRAY_IN=OPT_ARRAY_IN, KNOWN_OPT_ARRAY_OUT=KNOWN_OPT_ARRAY_OUT)
        OPT_ALLOC_ARRAY_OUT_DIM_1 = 0
      END IF
    ELSE
      IF (OPT_ALLOC_ARRAY_OUT_PRESENT) THEN
        ALLOC_ARRAY_OUT_LOCAL = TEST_EXTENDED(N=N, OPT_ARRAY_IN=OPT_ARRAY_IN, OPT_ALLOC_ARRAY_OUT=OPT_ALLOC_ARRAY_OUT_LOCAL)
        OPT_ALLOC_ARRAY_OUT_DIM_1 = SIZE(OPT_ALLOC_ARRAY_OUT_LOCAL,1)
        OPT_ALLOC_ARRAY_OUT = LOC(OPT_ALLOC_ARRAY_OUT_LOCAL(1))
      ELSE
        ALLOC_ARRAY_OUT_LOCAL = TEST_EXTENDED(N=N, OPT_ARRAY_IN=OPT_ARRAY_IN)
        OPT_ALLOC_ARRAY_OUT_DIM_1 = 0
      END IF
    END IF
  ELSE
    IF (KNOWN_OPT_ARRAY_OUT_PRESENT) THEN
      IF (OPT_ALLOC_ARRAY_OUT_PRESENT) THEN
        ALLOC_ARRAY_OUT_LOCAL = TEST_EXTENDED(N=N, KNOWN_OPT_ARRAY_OUT=KNOWN_OPT_ARRAY_OUT, OPT_ALLOC_ARRAY_OUT=OPT_ALLOC_ARRAY_OUT&
&_LOCAL)
        OPT_ALLOC_ARRAY_OUT_DIM_1 = SIZE(OPT_ALLOC_ARRAY_OUT_LOCAL,1)
        OPT_ALLOC_ARRAY_OUT = LOC(OPT_ALLOC_ARRAY_OUT_LOCAL(1))
      ELSE
        ALLOC_ARRAY_OUT_LOCAL = TEST_EXTENDED(N=N, KNOWN_OPT_ARRAY_OUT=KNOWN_OPT_ARRAY_OUT)
        OPT_ALLOC_ARRAY_OUT_DIM_1 = 0
      END IF
    ELSE
      IF (OPT_ALLOC_ARRAY_OUT_PRESENT) THEN
        ALLOC_ARRAY_OUT_LOCAL = TEST_EXTENDED(N=N, OPT_ALLOC_ARRAY_OUT=OPT_ALLOC_ARRAY_OUT_LOCAL)
        OPT_ALLOC_ARRAY_OUT_DIM_1 = SIZE(OPT_ALLOC_ARRAY_OUT_LOCAL,1)
        OPT_ALLOC_ARRAY_OUT = LOC(OPT_ALLOC_ARRAY_OUT_LOCAL(1))
      ELSE
        ALLOC_ARRAY_OUT_LOCAL = TEST_EXTENDED(N=N)
        OPT_ALLOC_ARRAY_OUT_DIM_1 = 0
      END IF
    END IF
  END IF
  
  ALLOC_ARRAY_OUT_DIM_1 = SIZE(ALLOC_ARRAY_OUT_LOCAL,1)
  ALLOC_ARRAY_OUT = LOC(ALLOC_ARRAY_OUT_LOCAL(1))
END SUBROUTINE C_TEST_EXTENDED

subroutine one_up(person) bind(c)
  use iso_c_binding, only: c_double, c_int
  type, bind(c) :: fancy
     real(c_double) :: shirt
     integer(c_int) :: pants
  end type fancy
  type(fancy), intent(inout) :: person
  person%shirt = person%shirt + 1
  person%pants = person%pants + 2
end subroutine one_up

MODULE HOLDER
  IMPLICIT NONE

  TYPE INTERNAL
     REAL :: R
     INTEGER :: I, J
  END TYPE INTERNAL

CONTAINS

  SUBROUTINE TEST(A, B)
    REAL, INTENT(OUT), OPTIONAL :: A
    REAL, INTENT(IN) :: B
    IF (PRESENT(A)) THEN
       A = TEST_INTERNAL()
    END IF
  CONTAINS
    FUNCTION TEST_INTERNAL()
      REAL :: TEST_INTERNAL
      TEST_INTERNAL = 2.0 * B
    END FUNCTION TEST_INTERNAL
  END SUBROUTINE TEST

  SUBROUTINE PROC_TEST(A)
    ABSTRACT INTERFACE
       FUNCTION PTINT(B)
         TYPE USEFUL
            REAL :: R, S
         END TYPE USEFUL
         TYPE(USEFUL), INTENT(IN) :: B
         REAL PTINT
       END FUNCTION PTINT
    END INTERFACE
    PROCEDURE(PTINT) :: A

  END SUBROUTINE PROC_TEST

END MODULE HOLDER






PROGRAM TRY_SOMETHING
  USE HOLDER
  IMPLICIT NONE
  REAL :: FIRST, SECOND
  TYPE(INTERNAL), DIMENSION(2,2) :: CUSTOM_TYPE

  CUSTOM_TYPE%I = 1
  CUSTOM_TYPE%J = 0
  CUSTOM_TYPE(:,:)%R = 1.0
  PRINT *, CUSTOM_TYPE(:,:)

  ! FIRST = 1.0
  ! SECOND = 2.0

  ! PRINT *, FIRST
  ! PRINT *, SECOND
  ! CALL TEST(A=FIRST, B=SECOND)
  ! PRINT *, FIRST
  ! PRINT *, SECOND

END PROGRAM TRY_SOMETHING

SUBROUTINE TEST_STANDARD(QUADRATIC, STEPS, SOLUTION, MAX_WINDOW)
  IMPLICIT NONE
  ! Minimize a quadratic by taking random 
  INTEGER, INTENT(IN) :: STEPS
  REAL, INTENT(INOUT) :: SOLUTION
  REAL, INTENT(IN), OPTIONAL :: MAX_WINDOW
  INTERFACE
     FUNCTION QUADRATIC(X) RESULT(Y)
       REAL, INTENT(IN) :: X
       REAL :: Y
     END FUNCTION QUADRATIC
  END INTERFACE
  ! Local variables.
  REAL :: DEFAULT_WINDOW
  REAL :: W, MOVEMENT, QVALUE, UVALUE
  INTEGER :: I
  ! Set the default window.
  IF (PRESENT(MAX_WINDOW)) THEN ; DEFAULT_WINDOW = MAX_WINDOW
  ELSE                          ; DEFAULT_WINDOW = 8.0
  END IF
  ! Initialize the value of the function.
  QVALUE = QUADRATIC(SOLUTION)
  W = DEFAULT_WINDOW
  ! Search randomly.
  DO I = 1, STEPS
     ! Generate a random movement.
     CALL RANDOM_NUMBER(MOVEMENT)
     MOVEMENT = W * (MOVEMENT - 0.5)
     UVALUE = QUADRATIC(SOLUTION+MOVEMENT)
     ! If this is better, take the step and reset the search window.
     IF (UVALUE < QVALUE) THEN
        SOLUTION = SOLUTION + MOVEMENT
        QVALUE = UVALUE
        W = DEFAULT_WINDOW
     ! This is not better, shrink the search window (increase likely of success).
     ELSE ;  W = W / 2.0
     END IF
  END DO
END SUBROUTINE TEST_STANDARD

SUBROUTINE TEST(N, OUT)
  ! Simple allocation test, allocate a real array of size N.
  INTEGER, INTENT(IN) :: N
  REAL, INTENT(OUT), ALLOCATABLE :: OUT(:)
  ! Local variables.
  INTEGER :: I
  ALLOCATE(OUT(1:I))
  DO I = 1, N
     OUT(I) = I
  END DO
END SUBROUTINE TEST

!     Module generated by fmodpy for fortran file named 'PROCEDURE'     
!=====================================================================
MODULE PROCEDURE_WRAPPER
  ! Any necessary "USE" statements
  
  ! Make sure it is clear that no implicit types are used in this wrapper
  IMPLICIT NONE
  ! Any interfaces defined for "PROCEDURE" declarations
  
    
  ABSTRACT INTERFACE
     ! Fortran interface for declaring necessary "PROCEDURE" typed arguments
     SUBROUTINE QUADRATIC_INTERFACE( X, Y ) BIND(C)
    
       REAL, INTENT(IN) :: X
       REAL, INTENT(OUT) :: Y
     END SUBROUTINE QUADRATIC_INTERFACE
  END INTERFACE
    
    
    
  INTERFACE
     ! Fortran interface for passing assumed shapes to non-moduled functions.
     SUBROUTINE TEST_STANDARD( QUADRATIC, STEPS, SOLUTION, MAX_WINDOW &
          &)
       
       PROCEDURE(QUADRATIC_INTERFACE) :: QUADRATIC
       INTEGER, INTENT(IN) :: STEPS
       REAL, INTENT(INOUT) :: SOLUTION
       REAL, INTENT(IN), OPTIONAL :: MAX_WINDOW
     END SUBROUTINE TEST_STANDARD
  END INTERFACE
    
    

CONTAINS
  !     Fortran wrapper for TEST_STANDARD, callable from C     
  !========================================================

   SUBROUTINE c_TEST_STANDARD( QUADRATIC, STEPS, SOLUTION, MAX_WINDOW,&
     & MAX_WINDOW_PRESENT ) BIND(c)
    ! This subroutine's only purpose is to call the source fortran
    !  code while also being accessible from C.
    PROCEDURE(QUADRATIC_INTERFACE) :: QUADRATIC
    INTEGER, INTENT(IN) :: STEPS
    REAL, INTENT(INOUT) :: SOLUTION
    LOGICAL, INTENT(IN) :: MAX_WINDOW_PRESENT
    REAL, INTENT(IN), OPTIONAL :: MAX_WINDOW
    ! Preparation code before function call (copying character arrays)
    
    ! Calling source fortran function
    IF (MAX_WINDOW_PRESENT) THEN
       CALL TEST_STANDARD(QUADRATIC, STEPS, SOLUTION, MAX_WINDOW=MAX_W&
            &INDOW)
    ELSE
       CALL TEST_STANDARD(QUADRATIC, STEPS, SOLUTION)
    ENDIF
    ! Copying out any necessary values for return (character arrays)
    
  END SUBROUTINE c_TEST_STANDARD

END MODULE PROCEDURE_WRAPPER

! This file contains a few modules, only ADDITION is relevant.

MODULE NOTHING
END MODULE NOTHING


! This file contains a single module ADDITION.
MODULE CONSTANT
  REAL, PARAMETER :: C = 1.0 ! Comment should not mess this up
  INTEGER, PARAMETER :: D = 2, E = 3 ! Comment should not mess this up
END MODULE CONSTANT


! This module tests out private and public attributes and subroutines.
MODULE ADDITION
  USE EXTRA_CONSTANT, ONLY: B

  PRIVATE :: A_PR
  PRIVATE B_PR, NOTHING_PR
  REAL :: A_PR
  INTEGER :: B_PR

  PUBLIC
  REAL :: A_PUB
  INTEGER :: B_PUB
  REAL, DIMENSION(10) :: A_VEC_PUB
  REAL, DIMENSION(:), ALLOCATABLE :: B_VEC_PUB
  REAL, DIMENSION(:,:), ALLOCATABLE :: C_MAT_PUB

CONTAINS

  SUBROUTINE NOTHING_PR()
    ! Private subroutine that does nothing.
  END SUBROUTINE NOTHING_PR

  SUBROUTINE ADD_AB(C)
    ! Compute C = A_PUB + B_PUB.
    REAL, INTENT(OUT) :: C
    C = A_PUB + REAL(B_PUB)
  END SUBROUTINE ADD_AB

  SUBROUTINE SUB_VECS(C_VEC)
    ! Compute C_VEC = B_VEC_PUB - A_VEC_PUB.
    REAL, INTENT(OUT), DIMENSION(SIZE(A_VEC_PUB)) :: C_VEC
    IF (ALLOCATED(B_VEC_PUB)) THEN
       C_VEC(:) = B_VEC_PUB(:) - A_VEC_PUB(:)
    ELSE
       C_VEC(:) = -A_VEC_PUB(:)
    END IF
  END SUBROUTINE SUB_VECS

  SUBROUTINE RETURN_ALLOC(A)
    REAL, INTENT(OUT), DIMENSION(:), ALLOCATABLE :: A
  END SUBROUTINE RETURN_ALLOC

END MODULE ADDITION

! Define a simple subroutine that copies a derived type from A to B.
SUBROUTINE COPY_TYPE(N, A, B)
  IMPLICIT NONE
  TYPE :: TP(NX)
     INTEGER, LEN :: NX
     REAL, DIMENSION(NX) :: X
  END TYPE TP
  INTEGER, INTENT(IN) :: N
  TYPE(TP(N)), INTENT(IN)  :: A
  TYPE(TP(N)), INTENT(OUT) :: B
  B = A
END SUBROUTINE COPY_TYPE

! Run a program that tests derived type functionality.
PROGRAM TEST_DERIVED_TYPES
  IMPLICIT NONE
  ! Configuration.
  TYPE :: TP(NX)
     INTEGER, LEN :: NX
     REAL, DIMENSION(NX) :: X
  END TYPE TP
  INTEGER, PARAMETER :: N = 10
  ! Locals for testing.
  INTEGER :: I
  TYPE(TP(N)) :: A
  TYPE(TP(N)) :: B

  ! -----------------------------------------------------------------
  ! ! Define an interface to the externally defined subroutine above.
  ! INTERFACE
  !    SUBROUTINE COPY_TYPE(N, A, B)
  !      IMPLICIT NONE
  !      TYPE :: TP(NX)
  !         INTEGER, LEN :: NX
  !         REAL, DIMENSION(NX) :: X
  !      END TYPE TP
  !      INTEGER, INTENT(IN) :: N
  !      TYPE(TP(N)), INTENT(IN)  :: A
  !      TYPE(TP(N)), INTENT(OUT) :: B
  !    END SUBROUTINE COPY_TYPE
  ! END INTERFACE

  EXTERNAL :: COPY_TYPE
  ! -----------------------------------------------------------------

  ! Initialize A.
  DO I = 1, N
     A%X(I) = I
  END DO
  ! Call the test-running procedure.
  CALL COPY_TYPE(N, A, B)

END PROGRAM TEST_DERIVED_TYPES

SUBROUTINE TEST_SIMPLE_CHARACTER(A,C,B)
  CHARACTER, INTENT(IN), DIMENSION(:) :: A
  CHARACTER, INTENT(IN), OPTIONAL :: C
  CHARACTER, INTENT(OUT), DIMENSION(SIZE(A)) :: B
  ! Local
  INTEGER :: I
  B(:) = 'A'
  DO I = 1, SIZE(B)
     IF (PRESENT(C) .AND. (C .EQ. '1')) THEN
        B(I) = A(I)
     ELSE
        B(I) = CHAR(MOD(I,3))
     END IF
  END DO
END SUBROUTINE TEST_SIMPLE_CHARACTER

! python3 -c "import fmodpy as f; f.fimport('simple_character.f03', build_dir='.', verbose=True)"
! python3 -c "import og_fmodpy as f; f.wrap('simple_character.f03', working_directory='og_fmodpy', verbose=True)"

PURE FUNCTION TEST_SHAPES(a) RESULT(b)
  REAL, INTENT(IN), DIMENSION(:,:) :: a
  INTEGER :: b(SIZE(a,1), SIZE(a(1,:)))
  ! INTEGER :: b(SIZE(a,1), SIZE(a(1,3:4)))
  b(:,:) = INT(a(:,:))
END FUNCTION TEST_SHAPES

| 1.1.0<br>December 2020 | Supports MODULE wrapping and basic types. |
| 1.2.0<br>February 2021 | Fixing array size and dimension checks for optional <br> array arguments. Working towards support of types. |
| 1.2.1<br>February 2021 | Fixing install issue with setup.py |
| 1.2.2<br>May 2021 | Added support for complex types. |
| 1.3.0<br>May 2021 | Removed OG fmodpy, added complex256 tests work in <br> progress. |
| 1.3.1<br>June 2021 | Fixing minor bug in argument parsing. |
| 1.3.2<br>June 2021 | Adding ability to parse Fortran files with renamed <br> types. |
| 1.3.3<br>September 2021 | Fixed numerous minor bugs and typos. Added basic <br> support for characters, as long as they have no <br> length. |
| 1.3.4<br>October 2021 | Refactored parsing of SIZE(...) in assumed shape <br> array allocation during wrapping. Now supports <br> slightly more complicated arguments to the SIZE <br> function. |
| 1.4.0<br>January 2022 | Updated documentation parsing to not clear comments <br> on new lines after subroutine definition. Fixed <br> character array tests. Added basic support for <br> Fortran derived types as long as they are BIND(C) <br> already. |
| 1.4.1<br>February 2022 | Fixed usability bugs with derived types, added final <br> directory cleaning, fixed bug in module dependencies <br> that relied on .mod file, found bug in gfortran when <br> trying to support parameterized types. |
| 1.4.2<br>February 2022 | Derived type struct fields in Python are lower case <br> to match python-wrapped behaviors in the rest of the <br> package. |
| 1.4.3<br>March 2022 | Added warnings for long compilation, many optional <br> arguments, and included architecture in compiled <br> file names. |
| 1.4.3<br>March 2022 | Logical byte size adjustment from 03-27 that <br> supports C-bool types with only one byte. |
| 1.4.4<br>March 2022 | Logical byte size adjustment from 03-27 that <br> supports C-bool types with only one byte. |
| 1.4.5<br>April 2022 | Updated size measurements for arrays to 64 bit <br> integers. |
| 1.4.6<br>April 2022 | Name change of depends_files to dependencies. Missed <br> this upload last weekend. |
| 1.4.7<br>April 2022 | Updated dependency handling, automatic compilation <br> now starts with dependencies in order, source code <br> modification times are checked for all dependencies. |
| 1.4.8<br>May 2022 | Added support for types defined in subroutines in <br> standalone files. Updated test case to reflect new <br> addition. Added 'verbose_module' parameter for <br> setting the default verbosity of generated modules. |
| 1.5.0<br>July 2022 | Added the ability to load symbols from system <br> libraries, improves automatic dependency resolution. |
| 1.5.1<br>July 2022 | Minor modifications to fix some compilation and <br> import bugs when supporting generic search for <br> symbols. Symbol dependencies are now loaded within <br> the generated wrapper, to ensure correct operation <br> after the initial build. |
| 1.5.2<br>July 2022 | Added some additional standard library search paths <br> and renamed 'delete_destination' as 'overwrite'. <br> Also changed default configurations that were <br> strings being split into proper Python lists. |
